using FluentValidation;
using CMSMicroservice.Protobuf.Protos.FactorDetails;
namespace CMSMicroservice.Protobuf.Validator.FactorDetails;

public class GetAllFactorDetailsByFilterRequestValidator : AbstractValidator<GetAllFactorDetailsByFilterRequest>
{
    public GetAllFactorDetailsByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllFactorDetailsByFilterRequest>.CreateWithOptions((GetAllFactorDetailsByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
